﻿unit Tasks;

{$savepcu false}

uses LightPT;

procedure CheckTaskT(name: string);
begin
  case name of
   'Simple1': begin 
      FilterOnlyNumbers;
      CheckOutputNew(1,3,5,7,9);
   end;
   'Simple2': begin 
      FilterOnlyNumbers;
      CheckInput(Arr(cInt)*2);
      CheckOutputNew(Int(0)+Int(1));
   end;
   'Simple3': begin 
      FilterOnlyNumbers;
      CheckInput(Arr(cRe)*2);
      var (a,b) := (Re,Re);
      CheckOutputNew(a*b,2*(a+b));
   end;
   'Simple4': begin 
      FilterOnlyNumbers;
      CheckInput(Arr(cRe)*3);
      var (a,b,c) := (Re,Re,Re);
      CheckOutputNew((a+b+c)/3);
   end;
   'Simple5': begin 
      FilterOnlyNumbers;
      CheckInput(Arr(cRe)*4);
      var (x1,y1,x2,y2) := (Re,Re,Re,Re);
      CheckOutputNew(Sqrt((x2-x1)**2+(y2-y1)**2));
   end;
   'Simple6': begin 
     ColoredMessage('Напишите тест самостоятельно!',MsgColorOrange);
   end;
  'MinMax': begin 
    CheckInputCount(2);
    FilterOnlyNumbers;
    if IsInt(0) then
      CheckOutputNew(Min(Int(0),Int(1)),Max(Int(0),Int(1)))
    else CheckOutputNew(Min(Re(0),Re(1)),Max(Re(0),Re(1)));
  end;
   'If1': begin 
     FilterOnlyNumbers;
     ColoredMessage('Напишите тест самостоятельно!',MsgColorOrange);
   end;
   'Sum2': begin 
     FilterOnlyNumbers;
     CheckOutput(328065);
   end;
   'Sum2AB': begin 
     FilterOnlyNumbers;
     
   end;
   'Seq1': begin 
     FilterOnlyNumbers;
     var obj := new ObjectList;
     for var i:=1 to 49 step 2 do
       obj.Add(i);
     CheckOutputSeq(obj);
   end;
   'Seq2': begin 

   end;
   'Tabl1': begin 
     FilterOnlyNumbers;
     var obj := new ObjectList;
     for var i:=1 to 10 do
     begin  
       obj.Add(i);
       obj.Add(Sqrt(i));
     end;
     CheckOutputSeq(obj);
   end;
  
   'Digits': begin 
     FilterOnlyNumbers;
     CheckInput(Arr(cInt));
     var n := Int;
     var obj := new ObjectList;
     while n>0 do
     begin  
       obj.Add(n mod 10);
       n := n div 10;
     end;
     CheckOutputSeq(obj);
   end;
   'Divisors': begin 
     FilterOnlyNumbers;
     ColoredMessage('Напишите тест самостоятельно!',MsgColorOrange);
   end;
  
   'Arr1': CheckOutputNew(777,1,1,1,777);
   'ArrSum': begin 
      CheckInput(Arr(cInt)*10); // 
      FilterOnlyNumbers;
      var a := IntArr(10);
      var out := new ObjectList;
      out.AddRange(a);
      var sum := 0;
      foreach var x in a do
        sum += x;
      out.Add(sum);
      CheckOutputSeqNew(out); 
    end;
   'ArrCount': begin 
     
   end;
   'HW1': begin 
     
   end;
   
  end;
end;

initialization
  CheckTask := CheckTaskT;
finalization
end.